package com.sun.xml.internal.ws.spi.db;

import java.security.PrivilegedExceptionAction;
import java.security.PrivilegedActionException;
import java.security.AccessController;
import java.lang.reflect.Field;

public class FieldGetter extends PropertyGetterBase
{
    protected Field field;
    
    public FieldGetter(Field f) {
        this.field = f;
        this.type = f.getType();
    }
    
    public Field getField() {
        return this.field;
    }
    
    @Override
    public Object get(Object instance) {
        if (this.field.isAccessible()) {
            try {
                return this.field.get(instance);
            }
            catch (Exception e2) {
                e2.printStackTrace();
            }
            return null;
        }
        FieldGetter.PrivilegedGetter privilegedGetter = new FieldGetter.PrivilegedGetter(this.field, instance);
        try {
            AccessController.doPrivileged(privilegedGetter);
        }
        catch (PrivilegedActionException e) {
            e.printStackTrace();
        }
        return privilegedGetter.value;
    }
    
    @Override
    public <A> A getAnnotation(Class<A> annotationType) {
        Class<A> c = annotationType;
        return this.field.getAnnotation(c);
    }
    
    static class PrivilegedGetter implements PrivilegedExceptionAction
    {
        private Object value;
        private Field field;
        private Object instance;
        
        public PrivilegedGetter(Field field, Object instance) {
            this.field = field;
            this.instance = instance;
        }
        
        @Override
        public Object run() throws IllegalAccessException {
            if (!this.field.isAccessible()) {
                this.field.setAccessible(true);
            }
            this.value = this.field.get(this.instance);
            return null;
        }
    }
}
